package de.geodbs;
import static de.geodbs.ConnectionParametersOra.*;

import java.awt.*;
import java.awt.image.RenderedImage;
import java.sql.*;

import javax.swing.JFrame;
import javax.swing.JPanel;

import oracle.spatial.georaster.JGeoRaster;
import oracle.spatial.georaster.image.GeoRasterImage;


public class OraGeoRasterExample {

public static void main (String[] args) {
	// Verbindung zur Datenbank aufbauen
	try (Connection db = DriverManager.getConnection(url, user, pw);
	     Statement query = db.createStatement()) {

		// JRaster einlesen
		String name = "sentinel2.tif pyramid";
		ResultSet res = query.executeQuery("SELECT georaster FROM GeoRasterkarten WHERE quelle = '"+name+"'");
		if (! res.next())
			return;
		JGeoRaster geoRaster = new JGeoRaster((Struct)res.getObject(1),db);
		res.close();
		// GeoRasterImage erzeugen und RenderedImage abfragen
		GeoRasterImage grImage = new GeoRasterImage(geoRaster);
		int pyramidLevel = 3;
		final RenderedImage img = grImage.getRasterImage(pyramidLevel);
		
		// Fenster und Panel erzeugen
		JPanel panel = new JPanel () {
			public void paintComponent (Graphics g) {
				Graphics2D g2 = (Graphics2D)g;
				g2.drawRenderedImage(img, null);   // das RenderedImage zeichnen
			}
		};
		panel.setPreferredSize(new Dimension(img.getWidth(), img.getHeight()));
		// Fenster erzeugen und mit Panel sichtbar machen
		JFrame win = new JFrame();
		win.setTitle("Ebene "+pyramidLevel+ " von "+name);
		win.add(panel);
		win.pack();
		win.setVisible(true);
	}
	// Fehler behandeln
	catch (Exception ex) {
		System.err.println("Fehler: " + ex);
		ex.printStackTrace();
	}
}

}
