package de.geodbs;
/**
 * Beispielprogramm, um in Oracle Spatial den krzesten Weg zu berechnen und zu speichern.
 * 
 * @author: Thomas Brinkhoff, https://www.geodbs.de/
 * @version: Auflage 4, Abs. 10.5.1.2
 */

import static de.geodbs.ConnectionParametersOra.*;

import java.sql.*;		// JDBC-Klassen

import oracle.spatial.network.*;		// Netzwerkklassen aus sdonm.jar


public class OraNetworkExample {

	public static void main (String[] args) {
		// Verbindung zur Datenbank aufbauen
		try (Connection db = DriverManager.getConnection(url, user, pw)) {
			// Krzesten Weg berechnen
			Network net = NetworkManager.readNetwork(db,"OldenburgNetz",true);
			Path path = NetworkManager.shortestPathDijkstra(net,1345,6436);
			//Path path = NetworkManager.shortestPathAStar(net,1345,6436);
			//Path path = NetworkManager.tspPath(net,new int[]{1345,2222,3234,4999,5345,6436},true,true,null);
			// Geometrie berechnen
			path.computeGeometry(0.5);
			// Pfad und Netzwerk speichern
			net.addPath(path);
			NetworkManager.writeNetwork(db,net);
			System.out.println("fertig!");
		}
		// Falls Fehler auftritt:
		catch (Exception ex) {
			System.err.println("Fehler: "+ex);
			ex.printStackTrace();
		}
	}
	
}
