package de.geodbs;
/**
 * Beispielprogramm, um Rasterkarten in BLOBs aus Oracle zu einzulesen und anzuzeigen.
 *
 * @author: Thomas Brinkhoff, https://www.geodbs.de/
 * @version: 4. Auflage, Abs. 11.2.2
 */

import static de.geodbs.ConnectionParametersOra.*;

import java.sql.*;		// JDBC-Klassen

import javax.swing.ImageIcon;		// Swing-Klassen
import javax.swing.JFrame;
import javax.swing.JLabel;


public class OraRasterFromBlob {

public static void main (String[] args) {
	// Verbindung zur Datenbank aufbauen
	try (Connection db = DriverManager.getConnection(url, user, pw);
		 Statement query = db.createStatement()) {
		// Datensatz abfragen
		ResultSet res = query.executeQuery("SELECT name, karte FROM Rasterkarten WHERE ID = 1");
		// Daten einlesen
		if (res.next()) {
			java.awt.image.BufferedImage image = javax.imageio.ImageIO.read( res.getBinaryStream(2) );
			// als Bild anzeigen
			JLabel picLabel = new JLabel(new ImageIcon(image));
			JFrame frame = new JFrame( "Raster "+res.getString(1) );
			frame.add(picLabel);
			frame.pack();
			frame.setVisible(true);
		}
		res.close();
	}
	// Fehler behandeln
	catch (Exception ex) {
		System.err.println("Fehler: " + ex);
		ex.printStackTrace();
	}
}
}
