package de.geodbs;
import java.sql.*;		// JDBC-Klassen

import static de.geodbs.ConnectionParametersOra.*;

import java.io.*;

import oracle.spatial.util.WKT;		// aus sdoutl.jar


public class OraSpatialWktExample {

public static void main (String[] args) {
	// Verbindung zur Datenbank aufbauen
	try (Connection db = DriverManager.getConnection(url, user, pw);
		 Statement statement = db.createStatement();) {
		// Anfrage ausfhren
		String sql = "SELECT * FROM GeoGemeinden WHERE code = 'DE03403000'";
		ResultSet result = statement.executeQuery(sql);
		WKT wkt = new WKT();
		if (result.next()) {
			// Attribut "geom" einlesen und
			Struct struct = (Struct) result.getObject("geom");
			byte[] wktPoint = wkt.fromStruct(struct);
			String wktString = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(wktPoint))).readLine();
			System.out.println(wktString);
			System.out.println();
		}
		result.close();
	} // try

	// Fehlerbehandlung:
	catch (Exception ex) {
		ex.printStackTrace();
		System.err.println("Fehler beim Datenbankzugriff: "+ex);
	}
}

}
