package de.geodbs;
/**
 * Beispielprogramm zum Zugriff auf Oracle Spatial mittels Struct.
 *
 * @author: Thomas Brinkhoff, https://www.geodbs.de/
 * @version: Auflage 4, Abs. 9.3.2.2
 */

import static de.geodbs.ConnectionParametersOra.*;

import java.sql.*;		// JDBC-Klassen


public class OraStructExample {

public static void main (String[] args) {
	// Verbindung zur Datenbank aufbauen
	try (Connection db = DriverManager.getConnection(url, user, pw)) {
		// Anfrage ausfhren
		String sql = "SELECT geo FROM GeoDbLand WHERE name = 'Steg'";
		try (Statement statement = db.createStatement();
				 ResultSet result = statement.executeQuery(sql)) {
			if (result.next()) {
			 	// Geometrie als Struct abfragen und auf Bestandteile zugreifen:
				Struct geo = (Struct)result.getObject("geo");
				Object[] attr = geo.getAttributes();
				java.math.BigDecimal gtype = (java.math.BigDecimal)attr[0];
				System.out.println("gtype: " + gtype);
				Array ordinates = (Array)attr[4];
				java.math.BigDecimal ordArray[] = (java.math.BigDecimal[])ordinates.getArray();
				System.out.print("ordinates: ");
				for (java.math.BigDecimal ord : ordArray)
					System.out.print(ord + " ");
				System.out.println();
			}
		}
	}
	// Fehlerbehandlung:
	catch (Exception ex) {
		System.err.println("Fehler beim Datenbankzugriff: "+ex);
	}
}

}
