package de.geodbs;
import static de.geodbs.ConnectionParametersOra.*;

import java.sql.*;		// JDBC-Klassen

import oracle.spatial.geometry.ElementExtractor;		// aus sdoapi.jar
import oracle.spatial.geometry.J3D_Geometry;
import oracle.spatial.geometry.JGeometry;


public class OraTINExample {

public static void main (String[] args) {
	// Verbindung zur Datenbank aufbauen und Anfrage ausfhren
	String sql = "SELECT SDO_TIN_PKG.TO_GEOMETRY(points,triangles,num_points,num_triangles,2,3,NULL) FROM TINBlockDaten";
	try (Connection db = DriverManager.getConnection(url, user, pw);
		 Statement statement = db.createStatement();
		 ResultSet result = statement.executeQuery(sql); ) {
		// Blcke durchlaufen
		while (result.next()) {
			// Geometrie holen
			Struct struct = (Struct) result.getObject(1);
			JGeometry geom = JGeometry.loadJS(struct);
			// 3D-Geometrie erzeugen
			J3D_Geometry geom3D = new J3D_Geometry(geom.getType(), geom.getSRID(), geom.getElemInfo(), geom.getOrdinatesArray());
			// Teilgeometrien durchlaufen
			ElementExtractor ee = new ElementExtractor(geom3D);
			int[] type = new int[1];
			J3D_Geometry elem = ee.nextElement(type);
			while (elem != null) {
				double[] ord = elem.getOrdinatesArray();
				for (int i=0; i<ord.length/3-1; i++)  // letzte Koordinate nicht wiederholen
					System.out.print("("+ord[3*i]+","+ord[3*i+1]+","+ord[3*i+2]+") ");
				System.out.println("["+type[0]+"]");
				elem = ee.nextElement(type);
			}
		}
	}
	// Fehler behandeln
	catch (Exception ex) {
		System.err.println("Fehler: " + ex);
		ex.printStackTrace();
	}
}

}
